#!/usr/local/bin/ruby
# cursor.rb creater
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

fn_cursor = '/usr/X11R6/include/X11/cursorfont.h'

print <<EOT
#!/usr/local/bin/ruby
# cursor.rb created #$0
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module Xlib
  class Cursor
    NAME2ID = {}
EOT

file = open fn_cursor, 'r'
while file.gets
  if /deprecated/
    define, symbol, value, comment = split
    $stderr.print "#{symbol}(#{value}) is deprecated.\n"
    next
  end
  next unless /^#define/
  define, symbol, value, comment = split
  symbol = symbol[3..-1] # chop 'XC_'
  print <<-EOT
    NAME2ID['#{symbol}'] = #{value}
  EOT
end
file.close

print <<EOT
    ID2NAME = NAME2ID.invert
    def id(name)
      NAME2ID[name]
    end
    alias_method :intern, :id
    module_function :id, :intern
    def name(id)
      ID2NAME[id]
    end
    alias_method :id2name, :name
    module_function :name, :id2name
  end
end
EOT
