require 'mkmf'

xlib_keysym = 'lib/xlib/keysym.rb'
xlib_cursor = 'lib/xlib/cursor.rb'

incs = %w(
-Wall
-I/usr/X11R6/include
-I/usr/local/include
)
libs = %w(
-L/usr/X11R6/lib
-L/usr/local/lib
)

 $CFLAGS = incs.join ' '
$LDFLAGS = libs.join ' '

have_header("X11/Xlib.h")
have_header("X11/Xutil.h")
have_library("X11", "XOpenDisplay")

`ruby keysym/create.rb > #{xlib_keysym} 2> /dev/null`
print "# #{xlib_keysym} created.\n"

`ruby cursor/create.rb > #{xlib_cursor} 2> /dev/null`
print "# #{xlib_cursor} created.\n"

have_header("X11/extensions/shape.h")
have_library("Xext", "XShapeCombineMask")

have_header("locale.h")
have_library("xpg4", "setlocale")

print "# no Ruby/GTK support.\n"
print "# edit extconf.rb if use this support.\n"
=begin Ruby/Gtk support
incs.push "-I/usr/local/include/gdk"
incs.push "-I."

 $CFLAGS = incs.join ' '
$LDFLAGS = libs.join ' '

if have_header("gdk.h")
  begin
    ENV['DISPLAY'] = ':0.0'
    require 'gtk'
    incs.push '-DUSE_RUBY_GTK'
    print "# Ruby/GTK support.\n"
  rescue LoadError
  end
end
=end

if have_header("Imlib.h")
  print "# Ruby/Imlib support.\n"
end

print "# no Debug mode.\n"
print "# edit extconf.rb if use this mode.\n"
=begin Debug mode
incs.push '-DDEBUG'
print "# Debug mode.\n"
=end

 $CFLAGS = incs.join ' '
$LDFLAGS = libs.join ' '

create_makefile("xlib")
