require 'xlib'
require 'imlib'

def usage
  print "usage: #$0 image_file\n"
  exit
end
image_file = ARGV.shift or usage

dis = Xlib::Display.new
id = Imlib::init dis

image = id.load_image image_file
w, h = image.width, image.height

win = dis.root.new_window w,h, nil,true, id.visual
win.title = image_file

image.apply win
rect = win.rect
mark = 'img'
filename = File::basename(image_file)
attr = [
  [:src     , "images/#{filename}" ],
  [:width   ,  rect.width          ],
  [:height  ,  rect.height         ],
  [:alt     ,  filename            ],
]
print '<'
attr.collect { |i| %!#{i[0].id2name}="#{i[1]}"! }.unshift(mark).join(' ').display
print '>'
print "\n"
