require 'xlib'
require 'imlib'

def usage
  print "usage: #$0 image_file\n"
  exit
end
image_file = ARGV.shift or usage
dis = Xlib::Display.new

id = Imlib::init dis

image = id.load_image image_file
w, h = image.width, image.height

win = Xlib::Window.new dis.root, w,h, nil,true, id.visual
win.title = image_file

image.render w,h
pmap, mask = image.move
win.pixmap = pmap
win.combine_mask mask if mask

win.show
dis.sync

win.event 'configure' do |ev|
  image.render ev.rect.width,ev.rect.height
  pmap.close
  pmap, mask = image.move
  win.pixmap = pmap
  win.combine_mask mask if mask
  win.clear
  dis.sync
end

while dis.event; end
