#!/usr/local/bin/ruby
# keysym.rb creater
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

fn_keysym = '/usr/X11R6/include/X11/keysym.h'
fn_keydef = '/usr/X11R6/include/X11/keysymdef.h'

defined = {}
file = open fn_keysym, 'r'
while file.gets
  next unless /^#define/
  define, symbol, value, comment = split
  defined[symbol] = true
end
file.close

print <<EOT
#!/usr/local/bin/ruby
# keysym.rb created #$0
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module Xlib
  module Keysym
    NAME2ID = {}
EOT

file = open fn_keydef, 'r'
while file.gets
  if /^#ifdef/
    ifdef, symbol, comment = split
    enable = defined[symbol]
    next
  end
  if /^#endif/
    enable = true
    next
  end
  next unless enable
  if /deprecated/
    define, symbol, value, comment = split
    $stderr.print "#{symbol}(#{value}) is deprecated.\n"
    next
  end
  next unless /^#define/
  define, symbol, value, comment = split
  symbol = symbol[3..-1] # chop 'XK_'
  print <<-EOT
    NAME2ID['#{symbol}'] = #{value}
  EOT
end
file.close

print <<EOT
    ID2NAME = NAME2ID.invert
    def id(name)
      NAME2ID[name]
    end
    alias_method :intern, :id
    module_function :id, :intern
    def name(id)
      ID2NAME[id]
    end
    alias_method :id2name, :name
    module_function :name, :id2name
  end
end
EOT
