#!/usr/local/bin/ruby
# cursor.rb created cursor/create.rb
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module Xlib
  class Cursor
    NAME2ID = {}
    NAME2ID['num_glyphs'] = 154
    NAME2ID['X_cursor'] = 0
    NAME2ID['arrow'] = 2
    NAME2ID['based_arrow_down'] = 4
    NAME2ID['based_arrow_up'] = 6
    NAME2ID['boat'] = 8
    NAME2ID['bogosity'] = 10
    NAME2ID['bottom_left_corner'] = 12
    NAME2ID['bottom_right_corner'] = 14
    NAME2ID['bottom_side'] = 16
    NAME2ID['bottom_tee'] = 18
    NAME2ID['box_spiral'] = 20
    NAME2ID['center_ptr'] = 22
    NAME2ID['circle'] = 24
    NAME2ID['clock'] = 26
    NAME2ID['coffee_mug'] = 28
    NAME2ID['cross'] = 30
    NAME2ID['cross_reverse'] = 32
    NAME2ID['crosshair'] = 34
    NAME2ID['diamond_cross'] = 36
    NAME2ID['dot'] = 38
    NAME2ID['dotbox'] = 40
    NAME2ID['double_arrow'] = 42
    NAME2ID['draft_large'] = 44
    NAME2ID['draft_small'] = 46
    NAME2ID['draped_box'] = 48
    NAME2ID['exchange'] = 50
    NAME2ID['fleur'] = 52
    NAME2ID['gobbler'] = 54
    NAME2ID['gumby'] = 56
    NAME2ID['hand1'] = 58
    NAME2ID['hand2'] = 60
    NAME2ID['heart'] = 62
    NAME2ID['icon'] = 64
    NAME2ID['iron_cross'] = 66
    NAME2ID['left_ptr'] = 68
    NAME2ID['left_side'] = 70
    NAME2ID['left_tee'] = 72
    NAME2ID['leftbutton'] = 74
    NAME2ID['ll_angle'] = 76
    NAME2ID['lr_angle'] = 78
    NAME2ID['man'] = 80
    NAME2ID['middlebutton'] = 82
    NAME2ID['mouse'] = 84
    NAME2ID['pencil'] = 86
    NAME2ID['pirate'] = 88
    NAME2ID['plus'] = 90
    NAME2ID['question_arrow'] = 92
    NAME2ID['right_ptr'] = 94
    NAME2ID['right_side'] = 96
    NAME2ID['right_tee'] = 98
    NAME2ID['rightbutton'] = 100
    NAME2ID['rtl_logo'] = 102
    NAME2ID['sailboat'] = 104
    NAME2ID['sb_down_arrow'] = 106
    NAME2ID['sb_h_double_arrow'] = 108
    NAME2ID['sb_left_arrow'] = 110
    NAME2ID['sb_right_arrow'] = 112
    NAME2ID['sb_up_arrow'] = 114
    NAME2ID['sb_v_double_arrow'] = 116
    NAME2ID['shuttle'] = 118
    NAME2ID['sizing'] = 120
    NAME2ID['spider'] = 122
    NAME2ID['spraycan'] = 124
    NAME2ID['star'] = 126
    NAME2ID['target'] = 128
    NAME2ID['tcross'] = 130
    NAME2ID['top_left_arrow'] = 132
    NAME2ID['top_left_corner'] = 134
    NAME2ID['top_right_corner'] = 136
    NAME2ID['top_side'] = 138
    NAME2ID['top_tee'] = 140
    NAME2ID['trek'] = 142
    NAME2ID['ul_angle'] = 144
    NAME2ID['umbrella'] = 146
    NAME2ID['ur_angle'] = 148
    NAME2ID['watch'] = 150
    NAME2ID['xterm'] = 152
    ID2NAME = NAME2ID.invert
    def id(name)
      NAME2ID[name]
    end
    alias_method :intern, :id
    module_function :id, :intern
    def name(id)
      ID2NAME[id]
    end
    alias_method :id2name, :name
    module_function :name, :id2name
  end
end
