#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module Xlib
  class Font
    def string=(str)
      @str = str
      @esc = escapement(str)
      @ink, @log = extents(str)
    end
    attr :str
    attr :esc
    attr :ink
    attr :log

    def width
      @log.width
    end
    def height
      @log.height
    end
    def lbearing
      @ink.x
    end
    def rbearing
      @ink.x + @ink.width
    end
    def ascent
      -@ink.y
    end
    def descent
      @ink.y + @ink.height
    end
  end
end

