#!/usr/local/bin/ruby
# keysym.rb created keysym/create.rb
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module Xlib
  module Keysym
    NAME2ID = {}
    NAME2ID['BackSpace'] = 0xFF08
    NAME2ID['Tab'] = 0xFF09
    NAME2ID['Linefeed'] = 0xFF0A
    NAME2ID['Clear'] = 0xFF0B
    NAME2ID['Return'] = 0xFF0D
    NAME2ID['Pause'] = 0xFF13
    NAME2ID['Scroll_Lock'] = 0xFF14
    NAME2ID['Sys_Req'] = 0xFF15
    NAME2ID['Escape'] = 0xFF1B
    NAME2ID['Delete'] = 0xFFFF
    NAME2ID['Multi_key'] = 0xFF20
    NAME2ID['Codeinput'] = 0xFF37
    NAME2ID['SingleCandidate'] = 0xFF3C
    NAME2ID['MultipleCandidate'] = 0xFF3D
    NAME2ID['PreviousCandidate'] = 0xFF3E
    NAME2ID['Kanji'] = 0xFF21
    NAME2ID['Muhenkan'] = 0xFF22
    NAME2ID['Henkan_Mode'] = 0xFF23
    NAME2ID['Henkan'] = 0xFF23
    NAME2ID['Romaji'] = 0xFF24
    NAME2ID['Hiragana'] = 0xFF25
    NAME2ID['Katakana'] = 0xFF26
    NAME2ID['Hiragana_Katakana'] = 0xFF27
    NAME2ID['Zenkaku'] = 0xFF28
    NAME2ID['Hankaku'] = 0xFF29
    NAME2ID['Zenkaku_Hankaku'] = 0xFF2A
    NAME2ID['Touroku'] = 0xFF2B
    NAME2ID['Massyo'] = 0xFF2C
    NAME2ID['Kana_Lock'] = 0xFF2D
    NAME2ID['Kana_Shift'] = 0xFF2E
    NAME2ID['Eisu_Shift'] = 0xFF2F
    NAME2ID['Eisu_toggle'] = 0xFF30
    NAME2ID['Kanji_Bangou'] = 0xFF37
    NAME2ID['Zen_Koho'] = 0xFF3D
    NAME2ID['Mae_Koho'] = 0xFF3E
    NAME2ID['Home'] = 0xFF50
    NAME2ID['Left'] = 0xFF51
    NAME2ID['Up'] = 0xFF52
    NAME2ID['Right'] = 0xFF53
    NAME2ID['Down'] = 0xFF54
    NAME2ID['Prior'] = 0xFF55
    NAME2ID['Page_Up'] = 0xFF55
    NAME2ID['Next'] = 0xFF56
    NAME2ID['Page_Down'] = 0xFF56
    NAME2ID['End'] = 0xFF57
    NAME2ID['Begin'] = 0xFF58
    NAME2ID['Select'] = 0xFF60
    NAME2ID['Print'] = 0xFF61
    NAME2ID['Execute'] = 0xFF62
    NAME2ID['Insert'] = 0xFF63
    NAME2ID['Undo'] = 0xFF65
    NAME2ID['Redo'] = 0xFF66
    NAME2ID['Menu'] = 0xFF67
    NAME2ID['Find'] = 0xFF68
    NAME2ID['Cancel'] = 0xFF69
    NAME2ID['Help'] = 0xFF6A
    NAME2ID['Break'] = 0xFF6B
    NAME2ID['Mode_switch'] = 0xFF7E
    NAME2ID['script_switch'] = 0xFF7E
    NAME2ID['Num_Lock'] = 0xFF7F
    NAME2ID['KP_Space'] = 0xFF80
    NAME2ID['KP_Tab'] = 0xFF89
    NAME2ID['KP_Enter'] = 0xFF8D
    NAME2ID['KP_F1'] = 0xFF91
    NAME2ID['KP_F2'] = 0xFF92
    NAME2ID['KP_F3'] = 0xFF93
    NAME2ID['KP_F4'] = 0xFF94
    NAME2ID['KP_Home'] = 0xFF95
    NAME2ID['KP_Left'] = 0xFF96
    NAME2ID['KP_Up'] = 0xFF97
    NAME2ID['KP_Right'] = 0xFF98
    NAME2ID['KP_Down'] = 0xFF99
    NAME2ID['KP_Prior'] = 0xFF9A
    NAME2ID['KP_Page_Up'] = 0xFF9A
    NAME2ID['KP_Next'] = 0xFF9B
    NAME2ID['KP_Page_Down'] = 0xFF9B
    NAME2ID['KP_End'] = 0xFF9C
    NAME2ID['KP_Begin'] = 0xFF9D
    NAME2ID['KP_Insert'] = 0xFF9E
    NAME2ID['KP_Delete'] = 0xFF9F
    NAME2ID['KP_Equal'] = 0xFFBD
    NAME2ID['KP_Multiply'] = 0xFFAA
    NAME2ID['KP_Add'] = 0xFFAB
    NAME2ID['KP_Separator'] = 0xFFAC
    NAME2ID['KP_Subtract'] = 0xFFAD
    NAME2ID['KP_Decimal'] = 0xFFAE
    NAME2ID['KP_Divide'] = 0xFFAF
    NAME2ID['KP_0'] = 0xFFB0
    NAME2ID['KP_1'] = 0xFFB1
    NAME2ID['KP_2'] = 0xFFB2
    NAME2ID['KP_3'] = 0xFFB3
    NAME2ID['KP_4'] = 0xFFB4
    NAME2ID['KP_5'] = 0xFFB5
    NAME2ID['KP_6'] = 0xFFB6
    NAME2ID['KP_7'] = 0xFFB7
    NAME2ID['KP_8'] = 0xFFB8
    NAME2ID['KP_9'] = 0xFFB9
    NAME2ID['F1'] = 0xFFBE
    NAME2ID['F2'] = 0xFFBF
    NAME2ID['F3'] = 0xFFC0
    NAME2ID['F4'] = 0xFFC1
    NAME2ID['F5'] = 0xFFC2
    NAME2ID['F6'] = 0xFFC3
    NAME2ID['F7'] = 0xFFC4
    NAME2ID['F8'] = 0xFFC5
    NAME2ID['F9'] = 0xFFC6
    NAME2ID['F10'] = 0xFFC7
    NAME2ID['F11'] = 0xFFC8
    NAME2ID['L1'] = 0xFFC8
    NAME2ID['F12'] = 0xFFC9
    NAME2ID['L2'] = 0xFFC9
    NAME2ID['F13'] = 0xFFCA
    NAME2ID['L3'] = 0xFFCA
    NAME2ID['F14'] = 0xFFCB
    NAME2ID['L4'] = 0xFFCB
    NAME2ID['F15'] = 0xFFCC
    NAME2ID['L5'] = 0xFFCC
    NAME2ID['F16'] = 0xFFCD
    NAME2ID['L6'] = 0xFFCD
    NAME2ID['F17'] = 0xFFCE
    NAME2ID['L7'] = 0xFFCE
    NAME2ID['F18'] = 0xFFCF
    NAME2ID['L8'] = 0xFFCF
    NAME2ID['F19'] = 0xFFD0
    NAME2ID['L9'] = 0xFFD0
    NAME2ID['F20'] = 0xFFD1
    NAME2ID['L10'] = 0xFFD1
    NAME2ID['F21'] = 0xFFD2
    NAME2ID['R1'] = 0xFFD2
    NAME2ID['F22'] = 0xFFD3
    NAME2ID['R2'] = 0xFFD3
    NAME2ID['F23'] = 0xFFD4
    NAME2ID['R3'] = 0xFFD4
    NAME2ID['F24'] = 0xFFD5
    NAME2ID['R4'] = 0xFFD5
    NAME2ID['F25'] = 0xFFD6
    NAME2ID['R5'] = 0xFFD6
    NAME2ID['F26'] = 0xFFD7
    NAME2ID['R6'] = 0xFFD7
    NAME2ID['F27'] = 0xFFD8
    NAME2ID['R7'] = 0xFFD8
    NAME2ID['F28'] = 0xFFD9
    NAME2ID['R8'] = 0xFFD9
    NAME2ID['F29'] = 0xFFDA
    NAME2ID['R9'] = 0xFFDA
    NAME2ID['F30'] = 0xFFDB
    NAME2ID['R10'] = 0xFFDB
    NAME2ID['F31'] = 0xFFDC
    NAME2ID['R11'] = 0xFFDC
    NAME2ID['F32'] = 0xFFDD
    NAME2ID['R12'] = 0xFFDD
    NAME2ID['F33'] = 0xFFDE
    NAME2ID['R13'] = 0xFFDE
    NAME2ID['F34'] = 0xFFDF
    NAME2ID['R14'] = 0xFFDF
    NAME2ID['F35'] = 0xFFE0
    NAME2ID['R15'] = 0xFFE0
    NAME2ID['Shift_L'] = 0xFFE1
    NAME2ID['Shift_R'] = 0xFFE2
    NAME2ID['Control_L'] = 0xFFE3
    NAME2ID['Control_R'] = 0xFFE4
    NAME2ID['Caps_Lock'] = 0xFFE5
    NAME2ID['Shift_Lock'] = 0xFFE6
    NAME2ID['Meta_L'] = 0xFFE7
    NAME2ID['Meta_R'] = 0xFFE8
    NAME2ID['Alt_L'] = 0xFFE9
    NAME2ID['Alt_R'] = 0xFFEA
    NAME2ID['Super_L'] = 0xFFEB
    NAME2ID['Super_R'] = 0xFFEC
    NAME2ID['Hyper_L'] = 0xFFED
    NAME2ID['Hyper_R'] = 0xFFEE
    NAME2ID['ISO_Lock'] = 0xFE01
    NAME2ID['ISO_Level2_Latch'] = 0xFE02
    NAME2ID['ISO_Level3_Shift'] = 0xFE03
    NAME2ID['ISO_Level3_Latch'] = 0xFE04
    NAME2ID['ISO_Level3_Lock'] = 0xFE05
    NAME2ID['ISO_Group_Shift'] = 0xFF7E
    NAME2ID['ISO_Group_Latch'] = 0xFE06
    NAME2ID['ISO_Group_Lock'] = 0xFE07
    NAME2ID['ISO_Next_Group'] = 0xFE08
    NAME2ID['ISO_Next_Group_Lock'] = 0xFE09
    NAME2ID['ISO_Prev_Group'] = 0xFE0A
    NAME2ID['ISO_Prev_Group_Lock'] = 0xFE0B
    NAME2ID['ISO_First_Group'] = 0xFE0C
    NAME2ID['ISO_First_Group_Lock'] = 0xFE0D
    NAME2ID['ISO_Last_Group'] = 0xFE0E
    NAME2ID['ISO_Last_Group_Lock'] = 0xFE0F
    NAME2ID['ISO_Left_Tab'] = 0xFE20
    NAME2ID['ISO_Move_Line_Up'] = 0xFE21
    NAME2ID['ISO_Move_Line_Down'] = 0xFE22
    NAME2ID['ISO_Partial_Line_Up'] = 0xFE23
    NAME2ID['ISO_Partial_Line_Down'] = 0xFE24
    NAME2ID['ISO_Partial_Space_Left'] = 0xFE25
    NAME2ID['ISO_Partial_Space_Right'] = 0xFE26
    NAME2ID['ISO_Set_Margin_Left'] = 0xFE27
    NAME2ID['ISO_Set_Margin_Right'] = 0xFE28
    NAME2ID['ISO_Release_Margin_Left'] = 0xFE29
    NAME2ID['ISO_Release_Margin_Right'] = 0xFE2A
    NAME2ID['ISO_Release_Both_Margins'] = 0xFE2B
    NAME2ID['ISO_Fast_Cursor_Left'] = 0xFE2C
    NAME2ID['ISO_Fast_Cursor_Right'] = 0xFE2D
    NAME2ID['ISO_Fast_Cursor_Up'] = 0xFE2E
    NAME2ID['ISO_Fast_Cursor_Down'] = 0xFE2F
    NAME2ID['ISO_Continuous_Underline'] = 0xFE30
    NAME2ID['ISO_Discontinuous_Underline'] = 0xFE31
    NAME2ID['ISO_Emphasize'] = 0xFE32
    NAME2ID['ISO_Center_Object'] = 0xFE33
    NAME2ID['ISO_Enter'] = 0xFE34
    NAME2ID['dead_grave'] = 0xFE50
    NAME2ID['dead_acute'] = 0xFE51
    NAME2ID['dead_circumflex'] = 0xFE52
    NAME2ID['dead_tilde'] = 0xFE53
    NAME2ID['dead_macron'] = 0xFE54
    NAME2ID['dead_breve'] = 0xFE55
    NAME2ID['dead_abovedot'] = 0xFE56
    NAME2ID['dead_diaeresis'] = 0xFE57
    NAME2ID['dead_abovering'] = 0xFE58
    NAME2ID['dead_doubleacute'] = 0xFE59
    NAME2ID['dead_caron'] = 0xFE5A
    NAME2ID['dead_cedilla'] = 0xFE5B
    NAME2ID['dead_ogonek'] = 0xFE5C
    NAME2ID['dead_iota'] = 0xFE5D
    NAME2ID['dead_voiced_sound'] = 0xFE5E
    NAME2ID['dead_semivoiced_sound'] = 0xFE5F
    NAME2ID['dead_belowdot'] = 0xFE60
    NAME2ID['First_Virtual_Screen'] = 0xFED0
    NAME2ID['Prev_Virtual_Screen'] = 0xFED1
    NAME2ID['Next_Virtual_Screen'] = 0xFED2
    NAME2ID['Last_Virtual_Screen'] = 0xFED4
    NAME2ID['Terminate_Server'] = 0xFED5
    NAME2ID['AccessX_Enable'] = 0xFE70
    NAME2ID['AccessX_Feedback_Enable'] = 0xFE71
    NAME2ID['RepeatKeys_Enable'] = 0xFE72
    NAME2ID['SlowKeys_Enable'] = 0xFE73
    NAME2ID['BounceKeys_Enable'] = 0xFE74
    NAME2ID['StickyKeys_Enable'] = 0xFE75
    NAME2ID['MouseKeys_Enable'] = 0xFE76
    NAME2ID['MouseKeys_Accel_Enable'] = 0xFE77
    NAME2ID['Overlay1_Enable'] = 0xFE78
    NAME2ID['Overlay2_Enable'] = 0xFE79
    NAME2ID['AudibleBell_Enable'] = 0xFE7A
    NAME2ID['Pointer_Left'] = 0xFEE0
    NAME2ID['Pointer_Right'] = 0xFEE1
    NAME2ID['Pointer_Up'] = 0xFEE2
    NAME2ID['Pointer_Down'] = 0xFEE3
    NAME2ID['Pointer_UpLeft'] = 0xFEE4
    NAME2ID['Pointer_UpRight'] = 0xFEE5
    NAME2ID['Pointer_DownLeft'] = 0xFEE6
    NAME2ID['Pointer_DownRight'] = 0xFEE7
    NAME2ID['Pointer_Button_Dflt'] = 0xFEE8
    NAME2ID['Pointer_Button1'] = 0xFEE9
    NAME2ID['Pointer_Button2'] = 0xFEEA
    NAME2ID['Pointer_Button3'] = 0xFEEB
    NAME2ID['Pointer_Button4'] = 0xFEEC
    NAME2ID['Pointer_Button5'] = 0xFEED
    NAME2ID['Pointer_DblClick_Dflt'] = 0xFEEE
    NAME2ID['Pointer_DblClick1'] = 0xFEEF
    NAME2ID['Pointer_DblClick2'] = 0xFEF0
    NAME2ID['Pointer_DblClick3'] = 0xFEF1
    NAME2ID['Pointer_DblClick4'] = 0xFEF2
    NAME2ID['Pointer_DblClick5'] = 0xFEF3
    NAME2ID['Pointer_Drag_Dflt'] = 0xFEF4
    NAME2ID['Pointer_Drag1'] = 0xFEF5
    NAME2ID['Pointer_Drag2'] = 0xFEF6
    NAME2ID['Pointer_Drag3'] = 0xFEF7
    NAME2ID['Pointer_Drag4'] = 0xFEF8
    NAME2ID['Pointer_Drag5'] = 0xFEFD
    NAME2ID['Pointer_EnableKeys'] = 0xFEF9
    NAME2ID['Pointer_Accelerate'] = 0xFEFA
    NAME2ID['Pointer_DfltBtnNext'] = 0xFEFB
    NAME2ID['Pointer_DfltBtnPrev'] = 0xFEFC
    NAME2ID['space'] = 0x020
    NAME2ID['exclam'] = 0x021
    NAME2ID['quotedbl'] = 0x022
    NAME2ID['numbersign'] = 0x023
    NAME2ID['dollar'] = 0x024
    NAME2ID['percent'] = 0x025
    NAME2ID['ampersand'] = 0x026
    NAME2ID['apostrophe'] = 0x027
    NAME2ID['parenleft'] = 0x028
    NAME2ID['parenright'] = 0x029
    NAME2ID['asterisk'] = 0x02a
    NAME2ID['plus'] = 0x02b
    NAME2ID['comma'] = 0x02c
    NAME2ID['minus'] = 0x02d
    NAME2ID['period'] = 0x02e
    NAME2ID['slash'] = 0x02f
    NAME2ID['0'] = 0x030
    NAME2ID['1'] = 0x031
    NAME2ID['2'] = 0x032
    NAME2ID['3'] = 0x033
    NAME2ID['4'] = 0x034
    NAME2ID['5'] = 0x035
    NAME2ID['6'] = 0x036
    NAME2ID['7'] = 0x037
    NAME2ID['8'] = 0x038
    NAME2ID['9'] = 0x039
    NAME2ID['colon'] = 0x03a
    NAME2ID['semicolon'] = 0x03b
    NAME2ID['less'] = 0x03c
    NAME2ID['equal'] = 0x03d
    NAME2ID['greater'] = 0x03e
    NAME2ID['question'] = 0x03f
    NAME2ID['at'] = 0x040
    NAME2ID['A'] = 0x041
    NAME2ID['B'] = 0x042
    NAME2ID['C'] = 0x043
    NAME2ID['D'] = 0x044
    NAME2ID['E'] = 0x045
    NAME2ID['F'] = 0x046
    NAME2ID['G'] = 0x047
    NAME2ID['H'] = 0x048
    NAME2ID['I'] = 0x049
    NAME2ID['J'] = 0x04a
    NAME2ID['K'] = 0x04b
    NAME2ID['L'] = 0x04c
    NAME2ID['M'] = 0x04d
    NAME2ID['N'] = 0x04e
    NAME2ID['O'] = 0x04f
    NAME2ID['P'] = 0x050
    NAME2ID['Q'] = 0x051
    NAME2ID['R'] = 0x052
    NAME2ID['S'] = 0x053
    NAME2ID['T'] = 0x054
    NAME2ID['U'] = 0x055
    NAME2ID['V'] = 0x056
    NAME2ID['W'] = 0x057
    NAME2ID['X'] = 0x058
    NAME2ID['Y'] = 0x059
    NAME2ID['Z'] = 0x05a
    NAME2ID['bracketleft'] = 0x05b
    NAME2ID['backslash'] = 0x05c
    NAME2ID['bracketright'] = 0x05d
    NAME2ID['asciicircum'] = 0x05e
    NAME2ID['underscore'] = 0x05f
    NAME2ID['grave'] = 0x060
    NAME2ID['a'] = 0x061
    NAME2ID['b'] = 0x062
    NAME2ID['c'] = 0x063
    NAME2ID['d'] = 0x064
    NAME2ID['e'] = 0x065
    NAME2ID['f'] = 0x066
    NAME2ID['g'] = 0x067
    NAME2ID['h'] = 0x068
    NAME2ID['i'] = 0x069
    NAME2ID['j'] = 0x06a
    NAME2ID['k'] = 0x06b
    NAME2ID['l'] = 0x06c
    NAME2ID['m'] = 0x06d
    NAME2ID['n'] = 0x06e
    NAME2ID['o'] = 0x06f
    NAME2ID['p'] = 0x070
    NAME2ID['q'] = 0x071
    NAME2ID['r'] = 0x072
    NAME2ID['s'] = 0x073
    NAME2ID['t'] = 0x074
    NAME2ID['u'] = 0x075
    NAME2ID['v'] = 0x076
    NAME2ID['w'] = 0x077
    NAME2ID['x'] = 0x078
    NAME2ID['y'] = 0x079
    NAME2ID['z'] = 0x07a
    NAME2ID['braceleft'] = 0x07b
    NAME2ID['bar'] = 0x07c
    NAME2ID['braceright'] = 0x07d
    NAME2ID['asciitilde'] = 0x07e
    NAME2ID['nobreakspace'] = 0x0a0
    NAME2ID['exclamdown'] = 0x0a1
    NAME2ID['cent'] = 0x0a2
    NAME2ID['sterling'] = 0x0a3
    NAME2ID['currency'] = 0x0a4
    NAME2ID['yen'] = 0x0a5
    NAME2ID['brokenbar'] = 0x0a6
    NAME2ID['section'] = 0x0a7
    NAME2ID['diaeresis'] = 0x0a8
    NAME2ID['copyright'] = 0x0a9
    NAME2ID['ordfeminine'] = 0x0aa
    NAME2ID['guillemotleft'] = 0x0ab
    NAME2ID['notsign'] = 0x0ac
    NAME2ID['hyphen'] = 0x0ad
    NAME2ID['registered'] = 0x0ae
    NAME2ID['macron'] = 0x0af
    NAME2ID['degree'] = 0x0b0
    NAME2ID['plusminus'] = 0x0b1
    NAME2ID['twosuperior'] = 0x0b2
    NAME2ID['threesuperior'] = 0x0b3
    NAME2ID['acute'] = 0x0b4
    NAME2ID['mu'] = 0x0b5
    NAME2ID['paragraph'] = 0x0b6
    NAME2ID['periodcentered'] = 0x0b7
    NAME2ID['cedilla'] = 0x0b8
    NAME2ID['onesuperior'] = 0x0b9
    NAME2ID['masculine'] = 0x0ba
    NAME2ID['guillemotright'] = 0x0bb
    NAME2ID['onequarter'] = 0x0bc
    NAME2ID['onehalf'] = 0x0bd
    NAME2ID['threequarters'] = 0x0be
    NAME2ID['questiondown'] = 0x0bf
    NAME2ID['Agrave'] = 0x0c0
    NAME2ID['Aacute'] = 0x0c1
    NAME2ID['Acircumflex'] = 0x0c2
    NAME2ID['Atilde'] = 0x0c3
    NAME2ID['Adiaeresis'] = 0x0c4
    NAME2ID['Aring'] = 0x0c5
    NAME2ID['AE'] = 0x0c6
    NAME2ID['Ccedilla'] = 0x0c7
    NAME2ID['Egrave'] = 0x0c8
    NAME2ID['Eacute'] = 0x0c9
    NAME2ID['Ecircumflex'] = 0x0ca
    NAME2ID['Ediaeresis'] = 0x0cb
    NAME2ID['Igrave'] = 0x0cc
    NAME2ID['Iacute'] = 0x0cd
    NAME2ID['Icircumflex'] = 0x0ce
    NAME2ID['Idiaeresis'] = 0x0cf
    NAME2ID['ETH'] = 0x0d0
    NAME2ID['Ntilde'] = 0x0d1
    NAME2ID['Ograve'] = 0x0d2
    NAME2ID['Oacute'] = 0x0d3
    NAME2ID['Ocircumflex'] = 0x0d4
    NAME2ID['Otilde'] = 0x0d5
    NAME2ID['Odiaeresis'] = 0x0d6
    NAME2ID['multiply'] = 0x0d7
    NAME2ID['Ooblique'] = 0x0d8
    NAME2ID['Ugrave'] = 0x0d9
    NAME2ID['Uacute'] = 0x0da
    NAME2ID['Ucircumflex'] = 0x0db
    NAME2ID['Udiaeresis'] = 0x0dc
    NAME2ID['Yacute'] = 0x0dd
    NAME2ID['THORN'] = 0x0de
    NAME2ID['ssharp'] = 0x0df
    NAME2ID['agrave'] = 0x0e0
    NAME2ID['aacute'] = 0x0e1
    NAME2ID['acircumflex'] = 0x0e2
    NAME2ID['atilde'] = 0x0e3
    NAME2ID['adiaeresis'] = 0x0e4
    NAME2ID['aring'] = 0x0e5
    NAME2ID['ae'] = 0x0e6
    NAME2ID['ccedilla'] = 0x0e7
    NAME2ID['egrave'] = 0x0e8
    NAME2ID['eacute'] = 0x0e9
    NAME2ID['ecircumflex'] = 0x0ea
    NAME2ID['ediaeresis'] = 0x0eb
    NAME2ID['igrave'] = 0x0ec
    NAME2ID['iacute'] = 0x0ed
    NAME2ID['icircumflex'] = 0x0ee
    NAME2ID['idiaeresis'] = 0x0ef
    NAME2ID['eth'] = 0x0f0
    NAME2ID['ntilde'] = 0x0f1
    NAME2ID['ograve'] = 0x0f2
    NAME2ID['oacute'] = 0x0f3
    NAME2ID['ocircumflex'] = 0x0f4
    NAME2ID['otilde'] = 0x0f5
    NAME2ID['odiaeresis'] = 0x0f6
    NAME2ID['division'] = 0x0f7
    NAME2ID['oslash'] = 0x0f8
    NAME2ID['ugrave'] = 0x0f9
    NAME2ID['uacute'] = 0x0fa
    NAME2ID['ucircumflex'] = 0x0fb
    NAME2ID['udiaeresis'] = 0x0fc
    NAME2ID['yacute'] = 0x0fd
    NAME2ID['thorn'] = 0x0fe
    NAME2ID['ydiaeresis'] = 0x0ff
    NAME2ID['Aogonek'] = 0x1a1
    NAME2ID['breve'] = 0x1a2
    NAME2ID['Lstroke'] = 0x1a3
    NAME2ID['Lcaron'] = 0x1a5
    NAME2ID['Sacute'] = 0x1a6
    NAME2ID['Scaron'] = 0x1a9
    NAME2ID['Scedilla'] = 0x1aa
    NAME2ID['Tcaron'] = 0x1ab
    NAME2ID['Zacute'] = 0x1ac
    NAME2ID['Zcaron'] = 0x1ae
    NAME2ID['Zabovedot'] = 0x1af
    NAME2ID['aogonek'] = 0x1b1
    NAME2ID['ogonek'] = 0x1b2
    NAME2ID['lstroke'] = 0x1b3
    NAME2ID['lcaron'] = 0x1b5
    NAME2ID['sacute'] = 0x1b6
    NAME2ID['caron'] = 0x1b7
    NAME2ID['scaron'] = 0x1b9
    NAME2ID['scedilla'] = 0x1ba
    NAME2ID['tcaron'] = 0x1bb
    NAME2ID['zacute'] = 0x1bc
    NAME2ID['doubleacute'] = 0x1bd
    NAME2ID['zcaron'] = 0x1be
    NAME2ID['zabovedot'] = 0x1bf
    NAME2ID['Racute'] = 0x1c0
    NAME2ID['Abreve'] = 0x1c3
    NAME2ID['Lacute'] = 0x1c5
    NAME2ID['Cacute'] = 0x1c6
    NAME2ID['Ccaron'] = 0x1c8
    NAME2ID['Eogonek'] = 0x1ca
    NAME2ID['Ecaron'] = 0x1cc
    NAME2ID['Dcaron'] = 0x1cf
    NAME2ID['Dstroke'] = 0x1d0
    NAME2ID['Nacute'] = 0x1d1
    NAME2ID['Ncaron'] = 0x1d2
    NAME2ID['Odoubleacute'] = 0x1d5
    NAME2ID['Rcaron'] = 0x1d8
    NAME2ID['Uring'] = 0x1d9
    NAME2ID['Udoubleacute'] = 0x1db
    NAME2ID['Tcedilla'] = 0x1de
    NAME2ID['racute'] = 0x1e0
    NAME2ID['abreve'] = 0x1e3
    NAME2ID['lacute'] = 0x1e5
    NAME2ID['cacute'] = 0x1e6
    NAME2ID['ccaron'] = 0x1e8
    NAME2ID['eogonek'] = 0x1ea
    NAME2ID['ecaron'] = 0x1ec
    NAME2ID['dcaron'] = 0x1ef
    NAME2ID['dstroke'] = 0x1f0
    NAME2ID['nacute'] = 0x1f1
    NAME2ID['ncaron'] = 0x1f2
    NAME2ID['odoubleacute'] = 0x1f5
    NAME2ID['udoubleacute'] = 0x1fb
    NAME2ID['rcaron'] = 0x1f8
    NAME2ID['uring'] = 0x1f9
    NAME2ID['tcedilla'] = 0x1fe
    NAME2ID['abovedot'] = 0x1ff
    NAME2ID['Hstroke'] = 0x2a1
    NAME2ID['Hcircumflex'] = 0x2a6
    NAME2ID['Iabovedot'] = 0x2a9
    NAME2ID['Gbreve'] = 0x2ab
    NAME2ID['Jcircumflex'] = 0x2ac
    NAME2ID['hstroke'] = 0x2b1
    NAME2ID['hcircumflex'] = 0x2b6
    NAME2ID['idotless'] = 0x2b9
    NAME2ID['gbreve'] = 0x2bb
    NAME2ID['jcircumflex'] = 0x2bc
    NAME2ID['Cabovedot'] = 0x2c5
    NAME2ID['Ccircumflex'] = 0x2c6
    NAME2ID['Gabovedot'] = 0x2d5
    NAME2ID['Gcircumflex'] = 0x2d8
    NAME2ID['Ubreve'] = 0x2dd
    NAME2ID['Scircumflex'] = 0x2de
    NAME2ID['cabovedot'] = 0x2e5
    NAME2ID['ccircumflex'] = 0x2e6
    NAME2ID['gabovedot'] = 0x2f5
    NAME2ID['gcircumflex'] = 0x2f8
    NAME2ID['ubreve'] = 0x2fd
    NAME2ID['scircumflex'] = 0x2fe
    NAME2ID['kra'] = 0x3a2
    NAME2ID['Rcedilla'] = 0x3a3
    NAME2ID['Itilde'] = 0x3a5
    NAME2ID['Lcedilla'] = 0x3a6
    NAME2ID['Emacron'] = 0x3aa
    NAME2ID['Gcedilla'] = 0x3ab
    NAME2ID['Tslash'] = 0x3ac
    NAME2ID['rcedilla'] = 0x3b3
    NAME2ID['itilde'] = 0x3b5
    NAME2ID['lcedilla'] = 0x3b6
    NAME2ID['emacron'] = 0x3ba
    NAME2ID['gcedilla'] = 0x3bb
    NAME2ID['tslash'] = 0x3bc
    NAME2ID['ENG'] = 0x3bd
    NAME2ID['eng'] = 0x3bf
    NAME2ID['Amacron'] = 0x3c0
    NAME2ID['Iogonek'] = 0x3c7
    NAME2ID['Eabovedot'] = 0x3cc
    NAME2ID['Imacron'] = 0x3cf
    NAME2ID['Ncedilla'] = 0x3d1
    NAME2ID['Omacron'] = 0x3d2
    NAME2ID['Kcedilla'] = 0x3d3
    NAME2ID['Uogonek'] = 0x3d9
    NAME2ID['Utilde'] = 0x3dd
    NAME2ID['Umacron'] = 0x3de
    NAME2ID['amacron'] = 0x3e0
    NAME2ID['iogonek'] = 0x3e7
    NAME2ID['eabovedot'] = 0x3ec
    NAME2ID['imacron'] = 0x3ef
    NAME2ID['ncedilla'] = 0x3f1
    NAME2ID['omacron'] = 0x3f2
    NAME2ID['kcedilla'] = 0x3f3
    NAME2ID['uogonek'] = 0x3f9
    NAME2ID['utilde'] = 0x3fd
    NAME2ID['umacron'] = 0x3fe
    NAME2ID['Greek_ALPHAaccent'] = 0x7a1
    NAME2ID['Greek_EPSILONaccent'] = 0x7a2
    NAME2ID['Greek_ETAaccent'] = 0x7a3
    NAME2ID['Greek_IOTAaccent'] = 0x7a4
    NAME2ID['Greek_IOTAdiaeresis'] = 0x7a5
    NAME2ID['Greek_OMICRONaccent'] = 0x7a7
    NAME2ID['Greek_UPSILONaccent'] = 0x7a8
    NAME2ID['Greek_UPSILONdieresis'] = 0x7a9
    NAME2ID['Greek_OMEGAaccent'] = 0x7ab
    NAME2ID['Greek_accentdieresis'] = 0x7ae
    NAME2ID['Greek_horizbar'] = 0x7af
    NAME2ID['Greek_alphaaccent'] = 0x7b1
    NAME2ID['Greek_epsilonaccent'] = 0x7b2
    NAME2ID['Greek_etaaccent'] = 0x7b3
    NAME2ID['Greek_iotaaccent'] = 0x7b4
    NAME2ID['Greek_iotadieresis'] = 0x7b5
    NAME2ID['Greek_iotaaccentdieresis'] = 0x7b6
    NAME2ID['Greek_omicronaccent'] = 0x7b7
    NAME2ID['Greek_upsilonaccent'] = 0x7b8
    NAME2ID['Greek_upsilondieresis'] = 0x7b9
    NAME2ID['Greek_upsilonaccentdieresis'] = 0x7ba
    NAME2ID['Greek_omegaaccent'] = 0x7bb
    NAME2ID['Greek_ALPHA'] = 0x7c1
    NAME2ID['Greek_BETA'] = 0x7c2
    NAME2ID['Greek_GAMMA'] = 0x7c3
    NAME2ID['Greek_DELTA'] = 0x7c4
    NAME2ID['Greek_EPSILON'] = 0x7c5
    NAME2ID['Greek_ZETA'] = 0x7c6
    NAME2ID['Greek_ETA'] = 0x7c7
    NAME2ID['Greek_THETA'] = 0x7c8
    NAME2ID['Greek_IOTA'] = 0x7c9
    NAME2ID['Greek_KAPPA'] = 0x7ca
    NAME2ID['Greek_LAMDA'] = 0x7cb
    NAME2ID['Greek_LAMBDA'] = 0x7cb
    NAME2ID['Greek_MU'] = 0x7cc
    NAME2ID['Greek_NU'] = 0x7cd
    NAME2ID['Greek_XI'] = 0x7ce
    NAME2ID['Greek_OMICRON'] = 0x7cf
    NAME2ID['Greek_PI'] = 0x7d0
    NAME2ID['Greek_RHO'] = 0x7d1
    NAME2ID['Greek_SIGMA'] = 0x7d2
    NAME2ID['Greek_TAU'] = 0x7d4
    NAME2ID['Greek_UPSILON'] = 0x7d5
    NAME2ID['Greek_PHI'] = 0x7d6
    NAME2ID['Greek_CHI'] = 0x7d7
    NAME2ID['Greek_PSI'] = 0x7d8
    NAME2ID['Greek_OMEGA'] = 0x7d9
    NAME2ID['Greek_alpha'] = 0x7e1
    NAME2ID['Greek_beta'] = 0x7e2
    NAME2ID['Greek_gamma'] = 0x7e3
    NAME2ID['Greek_delta'] = 0x7e4
    NAME2ID['Greek_epsilon'] = 0x7e5
    NAME2ID['Greek_zeta'] = 0x7e6
    NAME2ID['Greek_eta'] = 0x7e7
    NAME2ID['Greek_theta'] = 0x7e8
    NAME2ID['Greek_iota'] = 0x7e9
    NAME2ID['Greek_kappa'] = 0x7ea
    NAME2ID['Greek_lamda'] = 0x7eb
    NAME2ID['Greek_lambda'] = 0x7eb
    NAME2ID['Greek_mu'] = 0x7ec
    NAME2ID['Greek_nu'] = 0x7ed
    NAME2ID['Greek_xi'] = 0x7ee
    NAME2ID['Greek_omicron'] = 0x7ef
    NAME2ID['Greek_pi'] = 0x7f0
    NAME2ID['Greek_rho'] = 0x7f1
    NAME2ID['Greek_sigma'] = 0x7f2
    NAME2ID['Greek_finalsmallsigma'] = 0x7f3
    NAME2ID['Greek_tau'] = 0x7f4
    NAME2ID['Greek_upsilon'] = 0x7f5
    NAME2ID['Greek_phi'] = 0x7f6
    NAME2ID['Greek_chi'] = 0x7f7
    NAME2ID['Greek_psi'] = 0x7f8
    NAME2ID['Greek_omega'] = 0x7f9
    NAME2ID['Greek_switch'] = 0xFF7E
    NAME2ID['EcuSign'] = 0x20a0
    NAME2ID['ColonSign'] = 0x20a1
    NAME2ID['CruzeiroSign'] = 0x20a2
    NAME2ID['FFrancSign'] = 0x20a3
    NAME2ID['LiraSign'] = 0x20a4
    NAME2ID['MillSign'] = 0x20a5
    NAME2ID['NairaSign'] = 0x20a6
    NAME2ID['PesetaSign'] = 0x20a7
    NAME2ID['RupeeSign'] = 0x20a8
    NAME2ID['WonSign'] = 0x20a9
    NAME2ID['NewSheqelSign'] = 0x20aa
    NAME2ID['DongSign'] = 0x20ab
    NAME2ID['EuroSign'] = 0x20ac
    ID2NAME = NAME2ID.invert
    def id(name)
      NAME2ID[name]
    end
    alias_method :intern, :id
    module_function :id, :intern
    def name(id)
      ID2NAME[id]
    end
    alias_method :id2name, :name
    module_function :name, :id2name
  end
end
