
module MotionNotifier

  def motion_notify_loop
    return if @motion_notify && @motion_notify.status
    time = 1
    @motion_notify = Thread.new {
      while true
        events = get_motion_events time, 0
        unless events.empty?
          time, x, y = events[-1]
          yield x, y
        end
      end
    }
  end

  def motion_notify_step
    return if @motion_notify && @motion_notify.status
    time = 1
    prex, prey = 0, 0
    @motion_notify = Thread.new {
      while true
        events = get_motion_events time, 0
        unless events.empty?
          time, x, y = events[-1]
          yield x, y if x != prex || y != prey
          prex, prey = x, y
        end
      end
    }
  end

  def motion_notify_all
    return if @motion_notify && @motion_notify.status
    time = 1
    prex, prey = 0, 0
    @motion_notify = Thread.new {
      while true
        events = get_motion_events time, 0
        events.each { |event|
          time, x, y = event
          yield x, y if x != prex || y != prey
          prex, prey = x, y
        }
      end
    }
  end

end

