#!/usr/local/bin/ruby
# by YOSHIDA Kazuhiro (moriq.kazuhiro@nifty.ne.jp)

module Xlib
  class Rect
    def lt(a,b)
      if a<b then a else b end
    end
    def gt(a,b)
      if a>b then a else b end
    end
    def move(point)
      self.x += point.x
      self.y += point.y
      self
    end
    def union(r2)
      dest = Rect.new
      r1 = dup

      dest.x = lt r1.x, r2.x
      dest.y = lt r1.y, r2.y
      dest.width  = gt(r1.x + r1.width , r2.x + r2.width ) - dest.x
      dest.height = gt(r1.y + r1.height, r2.y + r2.height) - dest.y
      dest
    end
    def intersect(r2)
      ret = false

      dest = Rect.new
      r1 = dup

      r1,r2 = r2,r1 if r2.x < r1.x
      dest.x = r2.x

      r1_x2 = r1.x + r1.width
      r2_x2 = r2.x + r2.width

      if r2.x < r1_x2
        ret = true

        dest.width = if r1_x2 < r2_x2 then r1_x2 else r2_x2 end - dest.x
        r1,r2 = r2,r1 if r2.y<r1.y
        dest.y = r2.y

        r1_y2 = r1.y + r1.height
        r2_y2 = r2.y + r2.height

        if r2.y < r1_y2
          dest.height = if r1_y2 < r2_y2 then r1_y2 else r2_y2 end - dest.y
        end

        ret = false if dest.height == 0
        ret = false if dest.width  == 0
      end

      if ret then dest else nil end
    end
    def *(other)
      case other
      when Rect
        intersect other
      else
        raise TypeError
      end
    end
    def +(other)
      case other
      when Point
        move +other
      when Rect
        union other
      else
        raise TypeError
      end
    end
    def -(other)
      case other
      when Point
        move -other
      else
        raise TypeError
      end
    end
  end
end

