/*
 * pixmap_format.c
 */

#include "ruby.h"
#include "init.h"

#include "display.h"
#include "pixmap_format.h"

static VALUE sXlib_PixmapFormat;

VALUE
xlib_pixmap_format_setup(x)
	XPixmapFormatValues *x;
{
	return rb_struct_new(sXlib_PixmapFormat,
		INT2FIX(x->depth),
		INT2FIX(x->bits_per_pixel),
		INT2FIX(x->scanline_pad),
		0 );
}

static VALUE
xlib_display_get_pixmap_formats(self)
	VALUE self;
{
	t_display *disp;
	XPixmapFormatValues *pf_list;
	int num;
	VALUE *rb_list, *p;
	VALUE ary;
	int i;

	GetDisplay(self, disp);
	pf_list = XListPixmapFormats(disp->xdisplay, &num);
	rb_list = p = ALLOC_N(VALUE, num);
	for (i=0; i<num; i++, p++) {
		*p = xlib_pixmap_format_setup(&pf_list[i]);
	}
	ary = rb_ary_new4(num, rb_list);
	free(rb_list);
	free(pf_list);

	return ary;
}

void
xlib_init_pixmap_format()
{
	sXlib_PixmapFormat = rb_struct_define("PixmapFormat",
		"depth",
		"bits_per_pixel",
		"scanline_pad",
		0 );

	DefineMethodGet(display, pixmap_formats)

	rb_global_variable(&sXlib_PixmapFormat);
}
