#!/usr/local/bin/ruby
require 'xlib'

WIN_WIDTH  = 256
WIN_HEIGHT = 256
SQUARE_SIZE = 16

AREA_X_MIN = 0
AREA_X_MAX = WIN_WIDTH  - SQUARE_SIZE
AREA_Y_MIN = 0
AREA_Y_MAX = WIN_HEIGHT - SQUARE_SIZE

dis = Xlib::Display.new
win = dis.root.new_window WIN_WIDTH,WIN_HEIGHT
win.show

@gc = win.new_gc
@gc.func = Xlib::XOR
@gc.fg = dis.alloc_color('black') ^ dis.alloc_color('red')

@ox = @x = WIN_WIDTH  / 2
@oy = @y = WIN_HEIGHT / 3
@vx = +1.0
@vy = +1.2

@gc.fill_rect  @x, @y,SQUARE_SIZE,SQUARE_SIZE

def anime
   sleep 0.01
   @x += @vx
   @y += @vy
   if @x < AREA_X_MIN then @x = AREA_X_MIN; @vx = -@vx end
   if @x > AREA_X_MAX then @x = AREA_X_MAX; @vx = -@vx end
   if @y < AREA_Y_MIN then @y = AREA_Y_MIN; @vy = -@vy end
   if @y > AREA_Y_MAX then @y = AREA_Y_MAX; @vy = -@vy end

   @gc.fill_rect @ox,@oy,SQUARE_SIZE,SQUARE_SIZE
   @gc.fill_rect  @x, @y,SQUARE_SIZE,SQUARE_SIZE

   @ox = @x
   @oy = @y
end

while dis.event; anime; end
