#!/usr/local/bin/ruby
require 'xlib'

WIN_WIDTH  = 256
WIN_HEIGHT = 256
SQUARE_SIZE = 16

AREA_X_MIN = 0
AREA_X_MAX = WIN_WIDTH  - SQUARE_SIZE
AREA_Y_MIN = 0
AREA_Y_MAX = WIN_HEIGHT - SQUARE_SIZE

dis = Xlib::Display.new
win = dis.root.new_window WIN_WIDTH,WIN_HEIGHT
win.show

srand

class Cast
   def initialize(win,cn)
      @gc = win.new_gc
      @gc.func = Xlib::XOR
      @gc.fg = win.display.alloc_color('black') ^ win.display.alloc_color(cn)

      @ox = @x = rand(WIN_WIDTH )
      @oy = @y = rand(WIN_HEIGHT)
      @vx = +1.0
      @vy = +1.2
      @gc.fill_rect  @x, @y,SQUARE_SIZE,SQUARE_SIZE
   end

   def anime
      @x += @vx
      @y += @vy
      if @x < AREA_X_MIN then @x = AREA_X_MIN; @vx = -@vx end
      if @x > AREA_X_MAX then @x = AREA_X_MAX; @vx = -@vx end
      if @y < AREA_Y_MIN then @y = AREA_Y_MIN; @vy = -@vy end
      if @y > AREA_Y_MAX then @y = AREA_Y_MAX; @vy = -@vy end

      @gc.fill_rect @ox,@oy,SQUARE_SIZE,SQUARE_SIZE
      @gc.fill_rect  @x, @y,SQUARE_SIZE,SQUARE_SIZE

      @ox = @x
      @oy = @y
   end
end

casts = []
casts.push Cast.new(win,'red')
casts.push Cast.new(win,'green')
casts.push Cast.new(win,'blue')

while dis.event
   sleep 0.01
   casts.each { |c| c.anime }
end
