#!/usr/local/bin/ruby
require 'xlib'
require 'xlib/keysym'
require 'xlib/motion_notifier'

dis=Xlib::Display.new
win=dis.root.new_window 160,100,nil,true
win.title=$0
win.show
dis.flush

start, stop = 0, 0

win.event 'exposed' do |ev|
    print "exposed #{ev.rect} #{ev.count}\n"
end

win.event 'delete' do
  exit
end

win.event 'button_press' do |ev|
    start = ev.time
    p ev
end

win.event 'button_release' do |ev|
    stop = ev.time
    p ev
    p win.get_motion_events start, stop
    p Time.now.to_i
    p Time.now.to_i - stop
end

win.event 'enter_notify' do
    print "enter_notify\n"
end

win.event 'leave_notify' do
    print "leave_notify\n"
end

win.event 'key_press' do |ev|
p ev
#   print "key_press: #{Xlib::Keysym::name symbol}\n"
end

win.event 'key_release' do |ev|
p ev
#   print "key_release: #{Xlib::Keysym::name symbol}\n"
end

=begin

win.event 'motion_notify' do |x, y|
    print 'motion_notify: ', [x, y].join(' '), "\n"
end

Thread.abort_on_exception = true
time = 1
motion_notify = Thread.new {
  while true
    events = win.get_motion_events time, 0
    unless events.empty?
      time, x, y = events[-1]
    # p [x, y]
    end
  end
}

=end

win.extend MotionNotifier
win.motion_notify_step do |x, y|
  print 'motion_notify: ', [x, y].join(' '), "\n"
end

win.event 'configure' do |ev|
    p ev
    print "configure: #{ev}\n"
    p win.rect
end

while dis.event; end
