require 'xlib'

dis = Xlib::Display.new
win = dis.root.new_window 540, 480
win.show
image = dis.new_image 8, 8
palette = %w(
  black
  white
).collect { |i| dis.alloc_color i }
pmap = [
  [0,0,0,1,1,0,0,0],
  [0,0,1,0,0,1,0,0],
  [0,0,1,0,0,1,0,0],
  [0,1,0,1,1,0,1,0],
  [0,1,0,0,0,0,1,0],
  [0,1,0,0,0,0,1,0],
  [0,0,1,1,0,1,0,0],
  [0,0,0,0,1,0,0,0],
]
for y in 0...8
  for x in 0...8
    image.put_pixel x, y, palette[pmap[y][x]]
  end
end
x, y = 48, 32
Thread.new {
  while true
    win.put_image image, dis.gc, 8, 8, x, y
  end
}
dis.flush

win.event 'key_press' do |ev|
  case ev.keysym
  when ?h
    x-= 8
  when ?j
    y+= 8
  when ?k
    y-= 8
  when ?l
    x+= 8
  end
end

while dis.event
  dis.sync
end
