#!/usr/local/bin/ruby

require 'xlib'
require 'xlib/font'
require 'xlib/point'
require 'xlib/rect'

str = 'fontեFONTդ'

dis = Xlib::Display.new
p dis.visuals
win = dis.root.new_window 320,200
win.title = $0
win.show
gc = win.new_gc
gc.func = Xlib::XOR

default_fg = gc.fg
ink_color = dis.alloc_color 'pink'
log_color = dis.alloc_color 'red'

drawing = proc {
  gc.fg = ink_color; gc.draw_str 'ink', 0,16
  gc.fg = log_color; gc.draw_str 'logical', 0,32
  gc.fg = default_fg

  font_name = %w(
  -adobe-helvetica-medium-r-normal--14-*-*-*-c-*-iso8859-1
  -misc-fixed-medium-r-normal--14-*-*-*-c-*-jisx0208.1983-0
  )
  font = dis.new_font font_name
  point = Xlib::Point.new 8,64
  gc.draw_str str,point,font
  font.string = str
  gc.fg = ink_color; gc.draw_rect font.ink + point
  gc.fg = log_color; gc.draw_rect font.log + point
  gc.fg = default_fg

  font_name = %w(
  -*-courier-*-*-*--24-*-*-*-*-*-*-*
  -*-gothic-*-*-*--12-*-*-*-*-*-*-*
  )
  font = dis.new_font font_name
  point = Xlib::Point.new 8,96
  gc.draw_str str,point,font
  font.string = str
  p font.id_name
  gc.fg = ink_color; gc.draw_rect font.ink + point
  gc.fg = log_color; gc.draw_rect font.log + point
  gc.fg = default_fg
}
win.event 'exposed', drawing
drawing.call

dis.sync

while dis.event; end

