#!/usr/local/bin/ruby
require 'xlib'
include  Xlib

$fsize = 14
$wsize = $fsize / 2
$col = 30
$row = 10
$dec = 2

dis = Display.new
$white = dis.alloc_color 'white'
$black = dis.alloc_color 'black'
$royal_blue = dis.alloc_color 'royal blue'
win = dis.root.new_window $fsize * $col, $fsize * ($row+1) + $dec * 2
win.pixel = $white
win.title = $0
win.show

def win.init
  @gc = new_gc
  @row = 0
  @col = 0
  @text = []
  (0..$row).each { @text.push("") }
  edit = Point.new $wsize * @col, $fsize * (@row+1)
  stat =  Rect.new 0, $fsize * $row + $dec, width, $fsize
  @im = new_im true, edit, stat
  # draw cursor
  @gc.fg = $royal_blue
  @gc.fill_rect $wsize * @col, $fsize * @row + 2, 6, 13
end
win.init
dis.flush

def win.key_press(ev)
  # clear cursor
  @gc.fg = $white
  @gc.fill_rect $wsize * @col, $fsize * @row + 2, 6, 13

  s = ev.string
  if s
    @gc.fg = $black
    @gc.draw_str s, $wsize * @col, $fsize * (@row+1)
    @text[@row] << s
    @col += s.length
  else
    s = ev.keysym
    case s
      when 32..255
        @gc.fg = $black
        @gc.draw_str s.chr, $wsize * @col, $fsize * (@row+1)
        @text[@row] << s.chr
        @col += 1
      when 65293 # "\n"
        @row = (@row+1) % $row
        @col = 0
        @gc.fg = $white
        @gc.fill_rect 0, $fsize * @row + $dec, width, $fsize
      when 65505..65508; # L-Shift, R-Shift, L-Ctrl, R-Ctrl
    else
      p s
    end
  end
  @im.edit = Point.new $wsize * @col, $fsize * (@row+1)
  # draw cursor
  @gc.fg = $royal_blue
  @gc.fill_rect $wsize * @col, $fsize * @row + 2, 6, 13
end

def win.exposed
  clear
  (0..@row).each { |i| @gc.draw_str @text[i], 0, $fsize*(i+1) }
end

while dis.event; end
