#!/usr/local/bin/ruby
require 'xlib'

$fsize = 14
$wsize = $fsize / 2
$col = 30
$row = 10
$dec = 2
$stat_width = $fsize * 3

dis = Xlib::Display.new
$white = dis.alloc_color 'white'
$black = dis.alloc_color 'black'
$royal_blue = dis.alloc_color 'royal blue'

win = dis.root.new_window $fsize * $col, $fsize * ($row+1) + $dec * 2
win.pixel = $white
win.title = $0
win.show

class << win
  def init
    @gc = new_gc
    @row = 0
    @col = 0
    @text = []; (0..$row).each { @text.push("") }
    edit = Xlib::Point.new $wsize * @col, $fsize * (@row+1)
    stat = Xlib::Rect .new $wsize * @col, $fsize * (@row+1) + $dec, $stat_width, $fsize
    @im = new_im true, edit, stat
    draw_cursor $royal_blue
  end
  
  def draw_cursor(color)
    @gc.fg = color
    @gc.fill_rect $wsize * @col, $fsize * @row + $dec, $wsize-1, $fsize-1
  end
  
  def key_press(ev)
    draw_cursor $white
    s = ev.string
    if s
      @gc.fg = $black
      @gc.draw_str s, $wsize * @col, $fsize * (@row+1)
      @text[@row] << s
      @col += s.length
    else
      case ev.keysym
        when 32..255
          @gc.fg = $black
          @gc.draw_str s.chr, $wsize * @col, $fsize * (@row+1)
          @text[@row] << s.chr
          @col += 1
        when 65293 # "\n"
          @row = (@row+1) % $row
          @col = 0
          @gc.fg = $white
          @gc.fill_rect 0, $fsize * @row + $dec, width, $fsize
        when 65505..65508; # L-Shift, R-Shift, L-Ctrl, R-Ctrl
      else
        p s
      end
    end
    @im.edit = Xlib::Point.new $wsize * @col, $fsize * (@row+1)
    @im.stat = Xlib::Rect .new $wsize * @col, $fsize * (@row+1) + $dec, $stat_width, $fsize
    draw_cursor $royal_blue
  end
  
  def exposed
    clear
    (0..@row).each { |i| @gc.draw_str @text[i], 0, $fsize*(i+1) }
    draw_cursor $royal_blue
  end
end

win.init
dis.flush

while dis.event; end
