#!/usr/local/bin/ruby
require 'xlib'
include  Xlib 

dis=Display.new
if dis.depth < 8
  print "screen depth under 8 bit.\n"
  exit
end

$base = Array.new 256
unless dis.alloc_color_cells($base)
  print "fail to alloc color cells.\n"
  exit
end

$cols = Array.new 256
for r in 0..7
  for g in 0..7
    for b in 0..3
      i = r*32 + g*4 + b
      $cols[i] = Color.new r*36, g*36, b*85
      $cols[i].pixel = $base[i]
    end 
  end
end

dis.store_color($cols)
win = dis.root.new_window 256,256
def win.init
  @gc = new_gc
end
win.init
win.show
dis.flush

def win.exposed
  for x in 0..15
    for y in 0..15
      @gc.fg = $base[x*16 + y]
      @gc.fill_rect x*16,y*16, 15,15
    end
  end
  display.flush
end
win.exposed

while dis.event; end
