#!/usr/local/bin/ruby

require 'socket'
require 'kconv'

def dnload(url)
  port = 80
  if %r!^([a-z]+)://! =~ url
    url = $'
  end
  /([^\/]*)(.*)/ =~ url
  serv, file = $1, $2
  file = "/" if file == ""

  sock = TCPsocket.open(serv, port)
  sock.print "GET #{file} HTTP/1.0\r\nAccept:*/*\r\n\r\n"
  head = sock.gets("\r\n\r\n")
  list = head.split("\r\n")
  status = list.shift
  %r!(\w)/([\d.]+)\s+(\d+)\s*! =~ status
  proto, version, code, message = $1, $2.to_i, $3.to_i, $'
  if code != 200
    print "#{status}\n"
    return nil
  end

  header = {}
  list.each { |i|
    key, value = i.split(":")
    key.downcase!
    value.strip!
    header[key] = value
  }
  len = header['content-length']
  len = len.to_i if len
  body = if len then sock.read(len) else sock.read end
  sock.close

  body = Kconv.toeuc(body).sub(/\r\n/, "\n").tr("\cM", "")
  print head

  dirname, filename = File.split(file)

  ofile = if filename == ""
    "index.html"
  else
    filename
  end

  dirs = dirname.split("/")
  dirs[0] = serv
  dirs.unshift 'web'
  dirs.each { |dir|
    if dir[0] == ?~
       dir[0] =  ?_
    end

    if FileTest.exist?(dir)
    else
      Dir.mkdir dir
    end
    Dir.chdir dir
    print "cd #{dir}\n"
  }

  f = open(ofile, 'w')
  f.print body
  f.close
  $stderr.print "save #{ofile}\n"

  dirs.each { |dir|
    Dir.chdir '..'
  }

  body
end
