module Drag

  def initialize(*args)
    super(*args)

    @time = 0
    @drag_proc = proc {}

    self.event 'button_press' do |ev|
      @x, @y = ev.x, ev.y
      @time = ev.time
      @drag = true
    end

    self.event 'button_release' do |x, y, button, time|
      @drag = false
      drag_call
      @time = 0
      @x, @y = nil, nil
    end

=begin
    self.event 'motion_notify' do |x, y|
      if @drag
        @drag_proc.call x-@x, y-@y
        @x, @y = x, y
      end
    end
=end

  @th = Thread.new {
    while true
      drag_call if @drag
      Thread.pass
    end
  }

  end

  def drag_call
    events = self.get_motion_events @time, 0
    unless events.empty?
      time, x, y = events[-1]
      @drag_proc.call @x-x, @y-y
      @x, @y = x, y
    end
  end

  def drag
    @drag_proc = proc
  end
end

class DragWindow < Xlib::Window
  include Drag
end
