#!/usr/local/bin/ruby -T1

#
# linc.rb --  Link Checker  (console edition)
# @author  Kazuhiro Yoshida (moriq@ma2.seikyou.ne.jp)
# @version 0.14  1999.4.6
# @code    euc

port = 80
url = ARGV.shift || "localhost"

require "socket"

#      url ::= proto://serv[:port][/[dirs]]
# mini url ::=         serv[:port][/[dirs]]

def parse_url(url)
  if url =~ %!^([a-z]+):!
    # protocol specified
    proto = $1
    mini  = $'
#   if proto == "http"
#     # for http
#   else
#     print "error: #{proto} is unsupported protocol\n"
#     exit
#   end
  else
    proto = "http"
    mini  = url
  end
  
  serv, dirs = mini.scan(%!([^/]+)(.*)!)[0]
  serv, port = serv.scan(%!([^:]+)(.*)!)[0]
  port = port.to_i
  port = 80 if port == 0
  
  dirs = "/" if dirs == ""
  if dirs =~ %!/$!
#   file = "/"
  else
    dir_arr = dirs.split(%!/!)
    file = dir_arr.pop
    if file =~ /#/
      file, name = file.split(/#/)
    end
    dirs = dir_arr.join("/") + "/"
  end
  results = [proto, serv, port, dirs, file]
  print "URL: ", results.join(" "), "\n"
  results
end

proto, serv, port, dirs, file = parse_url(url)

begin
  sock = TCPsocket.open(serv, port)
  sock.print "GET #{dirs}#{file} HTTP/1.0\r\nAccept: */*\r\n\r\n"
  head = sock.gets("\r\n\r\n")
  len =
    if head =~ /^Content-length:\s*(\S+)/i
      $1.to_i
    else
      nil
    end
  body =
    if len
      sock.read(len)
    else
      sock.read
    end
  sock.close
rescue
  print "error: #$!\n"
  exit
end

response = head.scan(/(.*)$/)[0][0]
http, code, *rest = response.split(/ /)
info = rest.join(" ").strip!
code = code.to_i

if code != 200
  print "error: code=#{code}\n"
  exit
end

base = "http://#{serv}#{dirs}"

body.scan(/<(\w+)\s+href="(.*?)".*?>/i) { |note, href|
  pattern = $&
  note.downcase!
  
  if note == "base"
    proto, serv, port, dirs, file = parse_url(href)
    base = href
  end
  
  if href =~ %!^([a-z]+):!
    # for protocol
  else
    if base =~ %!/$!
      if href =~ %!^/!
        href = "#{proto}://#{serv}#{href}"
      else
        href = "#{base}#{href}"
      end
    else
      if href =~ %!^/!
        href = "#{base}#{href}"
      else
        href = "#{proto}://#{href}"
      end
    end
  end
  
  hproto, hserv, hport, hdirs, hfile = parse_url(href)
  
  begin
    sock = TCPsocket.open(hserv, hport)
    sock.print "GET #{hdirs}#{hfile} HTTP/1.0\r\nAccept: */*\r\n\r\n"
    head = sock.gets("\r\n\r\n")
    sock.close
    
    response = head.scan(/(.*)$/)[0][0]
    http, code, *rest = response.split(/ /)
    info = rest.join(" ").strip!
    code = code.to_i
    
    print %!#{note} #{href} (#{code} #{info})\n!
  rescue
    print %!#{note} #{href} (#$!)\n!
  end
}
