# more on X Window System
# by Kazuhiro Yoshida (moriq.kazuhiro@nifty.ne.jp)

def usage
  print "usage: #$0 file_name\n"
  exit
end
file_name = ARGV.shift or usage

require 'xlib'; include Xlib

$dis = Display.new
BLACK = $dis.alloc_color 'black'
WHITE = $dis.alloc_color 'white'
$win = $dis.root.new_window 16*40,16*24,WHITE
$pix = $win.new_pixmap
gc = $pix.new_gc
$text = []

def gc.load_file(filename)
  begin
    file = open filename
    $text = []
    while file.gets
      chomp!
      $text.push $_
    end
  ensure
    file.close
  end
  $pix = $win.new_pixmap $win.width,$text.size*16
  self.window = $pix
  self.fg = WHITE
  fill_rect 0,0,$pix.width,$pix.height
  self.fg = BLACK
  y = 14; $text.each { |line| draw_str line, 0, y; y+= 16 }
end
gc.load_file file_name

area = Rect.new 0,0,$pix.width,$pix.height

drag = nil
drag_x,drag_y = nil,nil
scrx,scry = 0,0

def sgn(x) if x==0 then 0 elsif x<0 then -1 else 1 end end
def more(a,b) if b>a then b else a end end
def less(a,b) if b<a then b else a end end

$win.event 'button_press' do |x,y,button|
  drag_x,drag_y = x,y
  drag = true
end

$win.event 'button_release' do |x,y,button|
  drag = false
  drag_x,drag_y = nil,nil
end

scry_min = 0
scry_max = $text.size*16 - $win.height

$win.event 'motion_notify' do |x,y|
  if drag
    dx,dy = x-drag_x,y-drag_y
    scry+= sgn(dy)*dy*dy
    scry = more scry, scry_min
    scry = less scry, scry_max
    moveto = Point.new 0,-scry
    $pix.copy_area $win,gc,area,moveto
    drag_x,drag_y = x,y
  end
end

$win.event 'exposed' do
  moveto = Point.new 0,0
  $pix.copy_area $win,gc,area,moveto
end

$win.title = file_name
$win.show

while $dis.event; $dis.sync end

