class Render

  def initialize
    @scry = 0
    @scry_min = 0
    @scry_max = 0
    @gc_direct = WIN.new_gc
    @pix = nil
  end
  attr :scry
  attr :scry_min
  attr :scry_max

  def point_mouse(part)
    s = if part.respond_to? :href then part.href else "" end
    @gc_direct.fg = FGCOLOR
    @gc_direct.bg = BGCOLOR
    @gc_direct.draw_str s.ljust(80), 8, WIN.height-8, nil, true
  end

  def update(scry=nil)
    if scry
      if scry == @scry
        return
      end
    else
      scry = @scry
    end
    scry = Util::less scry, @scry_max
    scry = Util::more scry, @scry_min
    @scry = scry

    area = Xlib::Rect.new 0, scry, WIN.width, WIN.height
    WIN.put_image @img, @gc, area
  end

  def rend(parts)
    area = parts[-1].area
    pixy = area.y + area.height + 24
    @scry_max = pixy - WIN.height

    @pix = WIN.new_pixmap WIN.width, pixy
    @gc = @pix.new_gc
    @gc.bg = BGCOLOR
    @gc.fg = BGCOLOR
    pix_area = Xlib::Rect.new 0, 0, @pix.width, @pix.height
    @gc.fill_rect pix_area

    print "rend ...\n"
    parts.each { |part|
      @gc.fg = if part.respond_to? :href
        LINKCOLOR
      else
        FGCOLOR
      end
      @gc.draw_str part.text, part.area.x, part.area.y+part.area.height, FONT
    }
    @img = @pix.get_image pix_area
    print "rend done.\n"

    @scry = 0
  end
end
