#!/usr/local/bin/ruby
require 'xlib'
include  Xlib 

STRING = ARGV.shift || 'hello'

dis=Display.new
if dis.depth < 8
  print "screen depth under 8 bit.\n"
  exit
end

$cols = Array.new 256
for r in 0..7
  for g in 0..7
    for b in 0..3
      i = r*32 + g*4 + b
      $cols[i] = Color.new r*36, g*36, b*85
    end 
  end
end

win = dis.root.new_window 256,256
def win.init
  @gc = new_gc
end
win.init
win.show
dis.flush

include Math
require 'util'
include Util
require 'xlib/point'
require 'xlib/rect'

module Xlib
class Pixmap
  def rotate(angle)
    area = Rect.new 0,0,width,height
    data = get_image(area)

    rad = angle*PI/180
    cos = cos rad
    sin = sin rad
    w,h = width, height

    rotx = (cos*w+sin*h).round
    roty =-(sin*w-cos*h).round
    print "negative rotx\n" if rotx<0
    print "negative roty\n" if roty<0

    area_rot = Rect.new 0,0,abs(rotx),abs(roty)
    area_pix = area + area_rot
    pixw, pixh = area_pix.width, area_pix.height
  # p area_pix
    pix = display.root.new_pixmap pixw, pixh
    i_src = get_image Rect.new(0,0,w,h)
    f = open 's', 'w'
    f.print i_src
    f.close
    octw = w+w%2
    p [i_src.size, w, h, octw]
    p i_src.size.to_f/h
    bpd_real = i_src.size.to_f/(h*octw)
    p bpd_real
    i_dst = pix.get_image area_pix
    bpd = display.depth/8
    p bpd
    exit if bpd != bpd_real 
    for y in 0...h
      ary = []
      for x in 0...w
        rotx = (cos*x+sin*y).round
        roty =-(sin*x-cos*y).round
        rotx+= pixw if rotx<0
        roty+= pixh if roty<0
      # p [rotx,roty]
        ary.push sprintf("%02x%02x", i_src[(x+y*w)*bpd], i_src[(x+y*w)*bpd+1])
        i_dst[(rotx+roty*pixw)*bpd,bpd] = i_src[(x+y*octw)*bpd,bpd]
      end
    # p ary
    end
    gc = pix.new_gc
    pix.put_image i_dst,gc,area_pix
    pix
  end
end
end

def win.exposed
  for x in 0..15
    for y in 0..15
      @gc.fg = display.alloc_color $cols[x*16 + y]
      @gc.fill_rect x*16,y*16, 15,15
    end
  end
  str = STRING
  ink, log = display.font.extents(str)
  pix = display.root.new_pixmap log.width,log.height
  gc = pix.new_gc
  gc.draw_str str, 0, log.height
  area = Rect.new 0,0,pix.width,pix.height
  moveto = Point.new 100,100
  pix.copy_area self, gc, area, moveto
  display.flush
  pix = pix.rotate(30)
# gc = pix.new_gc
# gc.draw_str str, 0, log.height
  area = Rect.new 0,0,pix.width,pix.height
  moveto = Point.new 120,100
  pix.copy_area self, gc, area, moveto
  display.flush
end
win.exposed

while dis.event
  dis.sync
end
