#!/usr/local/bin/ruby

klass = nil
block = false

while gets
  if block
    if /^\}/
      block = false
      klass = nil
    elsif /^\s*(\w+)\s*\(\s*(\w+)\s*\)/
      func = $1
      method = $2
      case func
      when /attr$/i; method << '(=)'
      end
      print klass, '#', method, "\n"
    elsif /^\s*(\w+)\s*\(\s*\w+\s*,\s*"?(\w+[?!=]?)"?.*?\)/
      func = $1
      method = $2
      case func
      when /get$/i
      when /set$/i;  method << '='
      when /is$/i;   method << '?'
      when /attr$/i; method << '(=)'
      end
      print klass, '#', method, "\n"
    end
  else
    if /^xlib_init_(\w+)/
      klass = $1.capitalize!
      case klass
      when 'Gc'; klass = 'GraphicContext'
      when 'Im'; klass = 'InputMethod'
      end
    end
    next unless klass
    if /^\{/
      block = true
    end
  end
end
